from gimpfu import *
import gtk, os




class settingsWindow:
    def __init__(
        self,
        img,
        threshold = None,
        blur = None,
        opacity = None,
        colored = None,
        colorHue = None,
        colorValue = None,
        colorSaturation = None,
        fixAlpha = None,
        isMainWindow = True
        ):

        self.img = img
        self.drw = img.active_layer
        self.preLay = None
        self.bloomLay = None
        self.alphaLay = None
        self.isMainWindow = isMainWindow


        if all((
            type(threshold) == int, threshold >= 0, threshold <= 255,
            type(blur) == int, blur >= 0, blur <= 500,
            type(opacity) == float, opacity >= 1, opacity <= 1000,
            type(colored) == bool,
            type(colorHue) == int, colorHue >= -180, colorHue <= 180,
            type(colorValue) == int, colorValue >= -100, colorValue <= 100,
            type(colorSaturation) == int, colorSaturation >= -100, colorSaturation <= 100,
            type(fixAlpha) == bool
            )):
            self.win = None
            self.threshold = threshold
            self.blur = blur
            self.colored = colored
            self.colorHue = colorHue
            self.colorValue = colorValue
            self.colorSaturation = colorSaturation
            self.fixAlpha = fixAlpha

        else:
            self.win = gtk.Window(gtk.WINDOW_TOPLEVEL)
            self.win.set_title("Bloom")
            self.win.set_border_width(10)
            self.win.connect("destroy", self.on_destroy)
            self.themeset(self.win)

            self.mainBox = gtk.VBox(False, 10) #same-size children, child padding
            self.win.add(self.mainBox)


            self.setsBox = gtk.HBox(False, 30)
            self.mainBox.pack_start(self.setsBox, True, True, 0)
            self.buttsBox = gtk.HBox(False, 5)
            self.mainBox.pack_start(self.buttsBox, True, True, 0)

            self.bloomBox = gtk.VBox(False, 10)
            self.setsBox.pack_start(self.bloomBox, True, True, 0)
            self.colorBox = gtk.VBox(False, 10)
            self.setsBox.pack_start(self.colorBox, True, True, 0)




            self.tSpinBox = gtk.HBox(False, 0)
            self.bloomBox.pack_start(self.tSpinBox, True, True, 0)

            self.threshLabel = gtk.Label("Light Threshold:   \n(lower is more)")
            self.tSpinBox.pack_start(self.threshLabel, False, False, 0)

            self.threshAdjust = gtk.Adjustment(250, 0, 255, 1, 10, 0)
            self.threshSpinner = gtk.SpinButton(self.threshAdjust, 0.0, 0)
            self.tSpinBox.pack_start(self.threshSpinner, True, True, 0)


            self.bSpinBox = gtk.HBox(False, 0)
            self.bloomBox.pack_start(self.bSpinBox, True, True, 0)

            self.blurLabel = gtk.Label("Blur Amount:   ")
            self.bSpinBox.pack_start(self.blurLabel, False, False, 0)

            self.blurAdjust = gtk.Adjustment(100, 0, 500, 10, 50, 0)
            self.blurSpinner = gtk.SpinButton(self.blurAdjust, 0.0, 0)
            self.bSpinBox.pack_start(self.blurSpinner, True, True, 0)


            self.oSpinBox = gtk.HBox(False, 0)
            self.bloomBox.pack_start(self.oSpinBox, True, True, 0)

            self.opacLabel = gtk.Label("Opacity %:   ")
            self.oSpinBox.pack_start(self.opacLabel, False, False, 0)

            self.opacAdjust = gtk.Adjustment(100, 1, 1000, 10, 50, 0)
            self.opacSpinner = gtk.SpinButton(self.opacAdjust, 0.0, 0)
            self.oSpinBox.pack_start(self.opacSpinner, True, True, 0)


            self.alphaFixChk = gtk.CheckButton("Fix Bloom on Alpha")
            self.bloomBox.pack_start(self.alphaFixChk, True, True, 0)




            self.colorChk = gtk.CheckButton("Colored Bloom")
            self.colorBox.pack_start(self.colorChk, True, True, 0)


            self.hSpinBox = gtk.HBox(False, 0)
            self.colorBox.pack_start(self.hSpinBox, True, True, 0)

            self.hueLabel = gtk.Label("Adjust Hue:   ")
            self.hSpinBox.pack_start(self.hueLabel, False, False, 0)

            self.hueAdjust = gtk.Adjustment(0, -180, 180, 5, 30, 0)
            self.hueSpinner = gtk.SpinButton(self.hueAdjust, 0.0, 0)
            self.hSpinBox.pack_start(self.hueSpinner, True, True, 0)


            self.vSpinBox = gtk.HBox(False, 0)
            self.colorBox.pack_start(self.vSpinBox, True, True, 0)

            self.valueLabel = gtk.Label("Adjust Value:   ")
            self.vSpinBox.pack_start(self.valueLabel, False, False, 0)

            self.valueAdjust = gtk.Adjustment(0, -100, 100, 5, 20, 0)
            self.valueSpinner = gtk.SpinButton(self.valueAdjust, 0.0, 0)
            self.vSpinBox.pack_start(self.valueSpinner, True, True, 0)


            self.sSpinBox = gtk.HBox(False, 0)
            self.colorBox.pack_start(self.sSpinBox, True, True, 0)

            self.saturLabel = gtk.Label("Adjust Saturation:   ")
            self.sSpinBox.pack_start(self.saturLabel, False, False, 0)

            self.saturAdjust = gtk.Adjustment(0, -100, 100, 5, 20, 0)
            self.saturSpinner = gtk.SpinButton(self.saturAdjust, 0.0, 0)
            self.sSpinBox.pack_start(self.saturSpinner, True, True, 0)




            self.execButton = gtk.Button("Execute")
            self.execButton.connect("clicked", self.main)
            self.buttsBox.pack_start(self.execButton, True, True, 0)

            self.prevButton = gtk.Button("Preveiw Threshold")
            self.prevButton.connect("clicked", self.preview)
            self.buttsBox.pack_start(self.prevButton, True, True, 0)

            self.clButton = gtk.Button("Clear Effects")
            self.clButton.connect("clicked", self.clLays)
            self.buttsBox.pack_start(self.clButton, True, True, 0)




            self.win.show()
            self.win.show_all()



    def main(self, *args):
        self.img.undo_group_start()
        if self.win:
            self.value_set()

        self.clLays()

        self.bloomLay = self.drw.copy()
        self.img.insert_layer(self.bloomLay)
        self.bloomLay.name = '{} Bloom'.format(self.drw.name)
        pdb.gimp_threshold(self.bloomLay, self.threshold, 255)

        if self.colored:
            colorLay = self.drw.copy()
            self.img.insert_layer(colorLay)
            colorLay.mode = 9
            self.bloomLay = self.img.merge_down(colorLay, 0)
            pdb.gimp_drawable_hue_saturation(self.bloomLay, 0, self.colorHue, self.colorValue, self.colorSaturation, 0)

        pdb.plug_in_colortoalpha(self.img, self.bloomLay, (0, 0, 0))


        if self.blur > 0:
            pdb.plug_in_gauss(self.img, self.bloomLay, self.blur, self.blur, 1)

            if self.opacity > 100:
                opacLay = self.bloomLay.copy()

                while self.opacity > 200:
                    opacMerge = opacLay.copy()
                    self.img.insert_layer(opacMerge)
                    self.bloomLay = self.img.merge_down(opacMerge, 0)
                    self.opacity -= 100

                opacMerge = opacLay.copy()
                self.img.insert_layer(opacMerge)
                opacMerge.opacity = self.opacity-100
                self.bloomLay = self.img.merge_down(opacMerge, 0)

            elif self.opacity < 100:
                self.bloomLay.opacity = self.opacity

            if self.fixAlpha:
                self.alphaLay = self.bloomLay.copy()
                self.img.insert_layer(self.alphaLay)
                self.alphaLay.name = '{} Bloom BG'.format(self.drw.name)
                pdb.gimp_image_lower_item_to_bottom(self.img, self.alphaLay)
                pdb.plug_in_colortoalpha(self.img, self.alphaLay, (0, 0, 0))

        self.bloomLay.mode = 4

        pdb.gimp_displays_flush()
        self.img.undo_group_end()


    def clLays(self, *args):
        self.img.undo_freeze()
        if self.preLay:
            self.img.remove_layer(self.preLay)
            self.preLay = None
        if self.bloomLay:
            self.img.remove_layer(self.bloomLay)
            self.bloomLay = None
        if self.alphaLay:
            self.img.remove_layer(self.alphaLay)
            self.alphaLay = None
        pdb.gimp_displays_flush()
        self.img.undo_thaw()


    def preview(self, widget):
        self.img.undo_freeze()
        if self.win:
            self.value_set()

        self.clLays()

        self.preLay = self.drw.copy()
        self.img.insert_layer(self.preLay)
        self.preLay.name = 'Preview Layer'

        pdb.gimp_threshold(self.preLay, self.threshold, 255)

        pdb.gimp_displays_flush()
        self.img.undo_thaw()


    def on_destroy(self, widget):
        self.img.undo_freeze()
        if self.preLay:
            self.img.remove_layer(self.preLay)
            self.preLay = None

        if self.isMainWindow:
            gtk.main_quit()

        pdb.gimp_displays_flush()
        self.img.undo_thaw()


    def value_set(self):
        self.threshold = int(self.threshSpinner.get_value())
        self.blur = int(self.blurSpinner.get_value())
        self.opacity = self.opacSpinner.get_value()
        self.colored = self.colorChk.get_active()
        self.colorHue = int(self.hueSpinner.get_value())
        self.colorValue = int(self.valueSpinner.get_value())
        self.colorSaturation = int(self.saturSpinner.get_value())
        self.fixAlpha = self.alphaFixChk.get_active()



    def themeset(self, item):
        try:
            cwd = os.getcwd()
            os.chdir("../share/gimp/2.0/themes")
            os.chdir("04-Darker")
            gtk.rc_parse("gtkrc")
            gtk.rc_reset_styles(gtk.settings_get_for_screen(item.get_screen()))
            os.chdir(cwd)
        except:
            pdb.gimp_message("Theme not found.")





def launch(img):
    mainWin = settingsWindow(img)
    if mainWin.win:
        gtk.main()
    else:
        mainWin.main()


# UNCOMMENT REGISTER TO ACTIVATE
register(
    "fsw-bloom",
    "Bleeds out bright areas.",
    """Variables required for hidden GUI (module) mode:

    threshold - integer  0 to 255
    blur - integer  0 to 500
    opacity - float  1 to 1000
    colored - boolean
    colorHue - integer  -180 to 180
    colorValue - integer  -100 to 100
    colorSaturation - integer  -100 to 100
    fixAlpha - boolean

    Import the settingsWindow class as a variable and create the object with these values input properly.
    You'll then be able to call the main() function of the class at will without any GUI's showing.
    Note you can also leave out the variables and set isMainWindow=False to use the class as a child window.""",
    "FierySwordswoman",
    "FierySwordswoman",
    "1989",
    "Bloom",
    "*",
    [(PF_IMAGE, "img", "Current Image", None)],
    [],
    launch,
    menu="<Image>/FierySwordswoman/Effects"
)

main()
